using Microsoft.Win32;
using System;
using System.Drawing;
using System.IO.Ports;
using System.IO;
using System.Windows.Forms;
using LAB24.Properties;
using System.Windows;

namespace LAB24
{   
    public partial class MainForm  
    { 
        public MainForm() 
        {
            InitializeComponent();if (transDefaultFormMainForm == null)	transDefaultFormMainForm = this;
           
            btnOpenOrClosePort.Click += new System.EventHandler( btnOpenOrClosePort_Click );             
            btnPort.Click += new System.EventHandler( btnPort_Click );                            
            Load += new System.EventHandler(Form1_Load);                                     
            //rtbMonitor.TextChanged += new System.EventHandler( rtbMonitor_TextChanged );                     
            tmrLookForPortChanges.Tick += new System.EventHandler( tmrLookForPortChanges_Tick ); 
        }
        private const string ButtonTextOpenPort = "Conectar";
        private const string ButtonTextClosePort = "Desconectar";
         private const string ModuleName = " Serie 1";
        string selectedPortState = "";
        internal MainForm MyMainForm; 
        internal PortSettingsDialog MyPortSettingsDialog; 
        internal ComPorts UserPort1;
       
        private delegate void AccessFormMarshalDelegate( string action, string textToAdd, Color textColor );



        public int cron = 0; /// responsavel pelo estouro do tempocontagem on line indicador
        public int cron1 = 0;
        public int reconectar = 0;
        public int timerDados = 0;
        ///  
        /// </summary>
        private Color colorTransmit = Color.DarkOrange;
        private int maximumTextBoxLength;
        private string receiveBuffer;
        private bool savedOpenPortOnStartup;
        private int userInputIndex;

            public static double FullPrimaryScreenHeight { get; }
            public static double FullPrimaryScreenWidth { get; }

         private void AccessForm( string action, string formText, Color textColor ) 
        {                                
            switch ( action ) 
            {
                case "AppendToMonitorTextBox":
                    
                     
                    rtbMonitor.AppendText( formText );                    
                    
                  
                    
                    if ( rtbMonitor.TextLength > maximumTextBoxLength ) 
                    {                         
                        TrimTextBoxContents();                         
                    }                    
                    break;

                case "DisplayStatus":
                    
                    //  Add text to the rtbStatus textbox using the specified color.
                    
                    DisplayStatus( formText, textColor ); 
                    
                    break;

                case "DisplayCurrentSettings":
                    
                    //  Display the current port settings in the ToolStripStatusLabel.
                    
                    DisplayCurrentSettings(); 
                    
                    break;

                default:
                    
                    break;
            }                      
        } 
     
        private void AccessFormMarshal( string action, string textToDisplay, Color textColor ) 
        {          
            AccessFormMarshalDelegate AccessFormMarshalDelegate1; 

            AccessFormMarshalDelegate1 = new AccessFormMarshalDelegate( AccessForm ); 

            object[] args = { action, textToDisplay, textColor };

            //  Call AccessForm, passing the parameters in args.
            try
            {

                base.Invoke(AccessFormMarshalDelegate1, args);
            }
            catch
            {


            }
        }       
 
        private void DisplayCurrentSettings() 
        {               
            ///////////////////////////////////////////////////////////////////////////////////////////////// 
            
            if ( ComPorts.comPortExists ) 
            {                 
                if ( ( !( ( UserPort1.SelectedPort == null ) ) ) ) 
                {                     
                    if ( UserPort1.SelectedPort.IsOpen ) 
                    { 
                        selectedPortState = "ATIVADA"; 
                        btnOpenOrClosePort.Text = ButtonTextClosePort;
                       // btnOpenOrClosePort.BackColor = Color.Navy;
                        btnOpenOrClosePort.ForeColor = Color.DarkTurquoise;

                        btnOpenOrClosePort.Visible = true;
                        btnOpenOrClosePort.Enabled = true;
                    } 
                    else 
                    { 
                        selectedPortState = "FECHADA"; 
                        btnOpenOrClosePort.Text =ButtonTextOpenPort;
                       // btnOpenOrClosePort.BackColor = Color.Chartreuse;
                        btnOpenOrClosePort.ForeColor = Color.Yellow;
                        
                    } 
                }


                //  //  //  //  //  //  //  ################ abaixo coleta os dados para apresentar na barra  de stattus^^^^^^^^^^^^^^^^^^^^^^^^^^

                UpdateStatusLabel( System.Convert.ToString( MyPortSettingsDialog.cmbPort.SelectedItem )  + "   " + selectedPortState);
                //lblOnOff.Text = (System.Convert.ToString(MyPortSettingsDialog.cmbPort.SelectedItem) + "   " + selectedPortState);
                //lblOnOff.Location = new Point(729, 580);

            } 
          
            
            else 
            { 
                DisplayStatus( ComPorts.noComPortsMessage, Color.Yellow );
               lblOnOff.Text = ("Checar portas COM   ");


            } 
        }        

        private void DisplayException( string moduleName, Exception ex ) 
        {    
            string errorMessage = null; 
            
            errorMessage = "Exceo: " + ex.Message + " Modulo: " + moduleName + ". Metodo: " + ex.TargetSite.Name; 
            
            DisplayStatus( errorMessage, Color.Yellow ); 
            
                        
        }        

        private void DisplayStatus( string status, Color textColor ) 
        {             
                      
        } 
      
        private void GetPreferences() 
        {      
            UserPort1.SavedPortName = Settings.Default.ComPort;
            UserPort1.SavedBitRate = Settings.Default.BitRate;
            UserPort1.SavedHandshake = Settings.Default.Handshaking;
            savedOpenPortOnStartup = Settings.Default.OpenComPortOnStartup;         
        } 
         
        private void InitializeDisplayElements() 
        {        
           
            
            maximumTextBoxLength = 100; 
                        
        }

        private void ProcessTextboxInput()
        {        
            IAsyncResult ar = null;
            string msg = null;
            int textLength = 0;
            string userInput = null;
        
           

            if (((rtbMonitor.Text.Length > userInputIndex + UserPort1.ReceivedDataLength) & ComPorts.comPortExists))
            {
                //  Retrieve the contents of the textbox.

                userInput = rtbMonitor.Text;

                //  Get the length of the new text.

                textLength = userInput.Length - userInputIndex;
           

                UserPort1.WriteToComPortDelegate1 = new ComPorts.WriteToComPortDelegate(UserPort1.WriteToComPort);

                ar = UserPort1.WriteToComPortDelegate1.BeginInvoke(userInput, new AsyncCallback(UserPort1.WriteCompleted), msg);

               

                AccessForm("UpdateStatusLabel", "", Color.Black);
            }
            else
            {
                

                UserPort1.ReceivedDataLength = 0;
            }

            
        }
                
        /// <summary> 
        /// Save user preferences for the COM port and parameters.
        /// </summary>

        private void SavePreferences() 
        {  
            // To define additional settings, in the Visual Studio IDE go to
            // Solution Explorer > right click on project name > Properties > Settings.

            if (MyPortSettingsDialog.cmbPort.SelectedIndex > -1) 
            {
                // The system has at least one COM port.

                Settings.Default.ComPort = MyPortSettingsDialog.cmbPort.SelectedItem.ToString();
                Settings.Default.BitRate = (int)MyPortSettingsDialog.cmbBitRate.SelectedItem;
                Settings.Default.Handshaking = (Handshake) MyPortSettingsDialog.cmbHandshaking.SelectedItem;
                Settings.Default.OpenComPortOnStartup = MyPortSettingsDialog.chkstart.Checked;

                Settings.Default.Save();    
            }
        }
        
        /// <summary>
        /// Use stored preferences or defaults to set the initial port parameters.
        /// </summary>

        private void SetInitialPortParameters() 
        {         
            GetPreferences(); 
            
            if ( ComPorts.comPortExists ) 
            {                 
                //  Select a COM port and bit rate using stored preferences if available.
                
                UsePreferencesToSelectParameters(); 
                
                //  Save the selected indexes of the combo boxes.
                
                MyPortSettingsDialog.SavePortParameters();                 
            } 
            else 
            {                 
                //  No COM ports have been detected. Watch for one to be attached.
                
                tmrLookForPortChanges.Start(); 
                DisplayStatus( ComPorts.noComPortsMessage, Color.Red );                 
            }             
            UserPort1.ParameterChanged = false;             
        }         
       
       

        private void SetPortParameters( string userPort, int userBitRate, Handshake userHandshake ) 
        {          
            try 
            {                 
               
                
                if ( ComPorts.comPortExists ) 
                {                     
                    if ( MyPortSettingsDialog.ParameterChanged() ) 
                    {                         
                       
                        
                        if ( ( string.Compare( MyPortSettingsDialog.oldPortName, userPort, true ) != 0 ) ) 
                        {                             
                            
                            
                            UserPort1.PreviousPort = UserPort1.SelectedPort; 
                            UserPort1.CloseComPort( UserPort1.SelectedPort ); 
                            
                           
                            
                            UserPort1.SelectedPort.PortName = userPort; 
                            UserPort1.PortChanged = true;                            
                        } 
                        
                       
                        
                        UserPort1.SelectedPort.BaudRate = userBitRate; 
                        UserPort1.SelectedPort.Handshake = userHandshake; 
                        
                        MyPortSettingsDialog.SavePortParameters(); 
                        
                        UserPort1.ParameterChanged = true;                         
                    } 
                    else 
                    { 
                        UserPort1.ParameterChanged = false;                         
                    } 
                }
            } 
            catch ( InvalidOperationException ex ) 
            {                 
                UserPort1.ParameterChanged = true; 
                DisplayException( ModuleName, ex );                 
            } 
            catch ( UnauthorizedAccessException ex ) 
            {                 
                UserPort1.ParameterChanged = true; 
                DisplayException( ModuleName, ex ); 
              
                
                UserPort1.CloseComPort( UserPort1.SelectedPort );                 
            } 
            catch ( System.IO.IOException ex ) 
            {                 
                UserPort1.ParameterChanged = true; 
                DisplayException( ModuleName, ex );                 
            } 
        }        
    
        

        private void TrimTextBoxContents() 
        {        
            RichTextBox rtbTemp = new RichTextBox(); 
            int textboxTrimSize = 0;           
                        
          
            
            textboxTrimSize = maximumTextBoxLength / 2; 
            
                      
        } 


        private void UpdateStatusLabel( string status ) 
        {        
            ToolStripStatusLabel1.Text = status; 
            barraStatus.Update();       //   responsavel pela barra infotmativa embaixo       
        } 

      
      
        private void UsePreferencesToSelectParameters() 
        {         
            int myPortIndex = 0;

            myPortIndex = MyPortSettingsDialog.SelectComPort(UserPort1.SavedPortName);
                
            MyPortSettingsDialog.SelectBitRate(UserPort1.SavedBitRate);

            UserPort1.SelectedPort.BaudRate = (int)MyPortSettingsDialog.cmbBitRate.SelectedItem;
                
            MyPortSettingsDialog.SelectHandshaking(UserPort1.SavedHandshake);

            UserPort1.SelectedPort.Handshake = (Handshake)MyPortSettingsDialog.cmbHandshaking.SelectedItem;

            MyPortSettingsDialog.chkstart.Checked = savedOpenPortOnStartup;           
        }
        
    

        private void btnOpenOrClosePort_Click( object sender, System.EventArgs e ) 
        {         
            if ( ( btnOpenOrClosePort.Text == ButtonTextOpenPort ) ) 
            { 
                UserPort1.OpenComPort(); 
                if ( UserPort1.SelectedPort.IsOpen ) 
                { 
                    btnOpenOrClosePort.Text = ButtonTextClosePort;
                    rtbMonitor.Enabled = true;

                }                 
            } 
            else 
            { 
                UserPort1.CloseComPort( UserPort1.SelectedPort ); 
                
                if ( !( UserPort1.SelectedPort.IsOpen ) ) 
                {
                    rtbMonitor.Clear();
                    rtbMonitor.Enabled = false;
                    btnOpenOrClosePort.Text = ButtonTextOpenPort;
                    
                }                 
            }             
        } 

      

        private void btnPort_Click( object sender, System.EventArgs e ) 
        {          
            ComPorts.FindComPorts(); 
            
            MyPortSettingsDialog.DisplayComPorts(); 
            MyPortSettingsDialog.SelectComPort( UserPort1.SelectedPort.PortName ); 
            MyPortSettingsDialog.SelectBitRate( UserPort1.SelectedPort.BaudRate ); 
            MyPortSettingsDialog.SelectHandshaking( UserPort1.SelectedPort.Handshake ); 
            
            UserPort1.ParameterChanged = false; 
      
            MyPortSettingsDialog.ShowDialog(); 
        } 

     
        private void Form1_Load( object sender, System.EventArgs e ) 
        {
            this.Top = 0;
            this.Left = 0;
            this.Width = System.Windows.Forms.Screen.PrimaryScreen.Bounds.Width/4;
            this.Height = System.Windows.Forms.Screen.PrimaryScreen.Bounds.Height/4;

            double panelH = this.Height * 0.90;
            double panelW = this.Width * 0.90;
            panel1.Size = new Size((int)panelW, (int)panelH);
            Show();                        

                UserPort1 = new ComPorts();

                MyPortSettingsDialog = new PortSettingsDialog();

                tmrLookForPortChanges.Interval = 100;
                tmrLookForPortChanges.Stop();

                InitializeDisplayElements();

                SetInitialPortParameters();

                if (ComPorts.comPortExists)
                {
                    UserPort1.SelectedPort.PortName = ComPorts.myPortNames[MyPortSettingsDialog.cmbPort.SelectedIndex];

                 
                    if (MyPortSettingsDialog.chkstart.Checked)
                    {
                        UserPort1.PortOpen = UserPort1.OpenComPort();
                        AccessForm("DisplayCurrentSettings", "", Color.Black);
                        AccessForm("DisplayStatus", "", Color.Black);
                    }
                    else
                    {
                        DisplayCurrentSettings();
                    }
                }

                 

                ComPorts.UserInterfaceData += new ComPorts.UserInterfaceDataEventHandler(AccessFormMarshal);
                PortSettingsDialog.UserInterfaceData += new PortSettingsDialog.UserInterfaceDataEventHandler(AccessFormMarshal);
                PortSettingsDialog.UserInterfacePortSettings += new PortSettingsDialog.UserInterfacePortSettingsEventHandler(SetPortParameters);
                       }         
        
       
        
        private void Form1_FormClosing( object sender, System.Windows.Forms.FormClosingEventArgs e ) 
        {             
            UserPort1.CloseComPort( UserPort1.SelectedPort ); 
            SavePreferences(); 
        } 


        private void tmrLookForPortChanges_Tick( object sender, System.EventArgs e ) 
        {         
            ComPorts.FindComPorts(); 
            
            if ( ComPorts.comPortExists ) 
            {                 
                tmrLookForPortChanges.Stop(); 
                DisplayStatus( "Portas COM encontradas.", Color.Black ); 
                
                MyPortSettingsDialog.DisplayComPorts(); 
                MyPortSettingsDialog.SelectComPort( UserPort1.SavedPortName ); 
                MyPortSettingsDialog.SelectBitRate(UserPort1.SavedBitRate); 
                MyPortSettingsDialog.SelectHandshaking( ( ( Handshake )( UserPort1.SavedHandshake ) ) ); 
                
                //  Set selectedPort.
                
                SetPortParameters( UserPort1.SavedPortName, UserPort1.SavedBitRate, ( ( Handshake )( UserPort1.SavedHandshake ) ) ); 
                
                DisplayCurrentSettings(); 
                UserPort1.ParameterChanged = true; 
            } 
        }

        // Default instance for Form

        public static string ASCIIToDecimal(string str)
        {
            string dec = string.Empty;

            for (int i = 0; i < str.Length; ++i)
            {
                string cDec = ((byte)str[i]).ToString();

                if (cDec.Length < 3)
                    cDec = cDec.PadLeft(3, '0');

                dec += cDec;
            }

            return dec;
        }

        private static MainForm transDefaultFormMainForm = null;
        public static MainForm TransDefaultFormMainForm
        { 
        	get
        	{ 
        		if (transDefaultFormMainForm == null)
        		{
        			transDefaultFormMainForm = new MainForm();
        		}
        		return transDefaultFormMainForm;
        	} 
        }




        private void Decodifica(String txtDecode)
        {
            //Variveis de decodificao dos dados da Injeo.
            int inicio = 0;
            String codigo = txtDecode;

            //Variveis para ponteiros
            int valorSensor;
            String sensor;
            char dadoRecebido;

            //Converso criptografia
            String convert;


                      
                        int invert = 0; // responsavel por locar numeros de ram para calculos
                        int invert2 = 0; // responsavel por locar numeros de ram para calculos
                        int invert3 = 0; // responsavel por locar numeros de ram para calculos
                        float ponto = 0;

                        rtbMonitor.Clear();

            String[] dados = codigo.Split('-');

            if (inicio > codigo.Length - 1)
            {
                inicio = 0;
            }

            for (int i = 0; i <= dados.Length; i++)
            {
                //Console.WriteLine(dados[i]);
                try
                {
   

                    sensor = dados[i].Substring(0, 1);

                    dadoRecebido = char.Parse(sensor);

                    //String valorSensorString = (dados[i].Trim(dadoRecebido));
                    dadoRecebido = char.Parse(sensor);

                    convert = dados[i].Trim(dadoRecebido);
                    //Console.WriteLine(convert);


                    valorSensor = int.Parse(ASCIIToDecimal(convert));

                }
                catch
                {
                    continue;
                }
               
                             switch (sensor)
                            {
                                
                            case "H": // leituras temp motor


                        timerDados = 0;
                        reconectar = 1;

                        lblOnOff.Text = "ONLINE";
                       // lblOnOff.Location = new Point(729, 580);
                        panel3.BackColor = Color.Lime;

                        timerReconecta.Enabled = false;
                        progressBar1.Visible = false;

                        try
                                {
                            //invert = int.Parse(texto[1].Trim());//trin recorta espaos em branco
                            //invert2 = invert * 2;
                            //invert = (invert - invert2) + 99;
                            double valorSensorD = (valorSensor * 1.3);
                            valorSensorD = (valorSensorD - 134) * -1;
                            lblMotor.Text = Convert.ToString((int)valorSensorD + "C");
                            
                                }

                                catch
                                {
                                    invert = 0;
                                }
                                cron = 0;

                                
                            
                                break;


                            case "G": // leituras voltagem
                        timerDados = 0;
                        reconectar = 1;

                        lblOnOff.Text = "ONLINE";
                        //lblOnOff.Location = new Point(729, 580);
                        panel3.BackColor = Color.Lime;

                        timerReconecta.Enabled = false;
                        progressBar1.Visible = false;

                        //lblOnOff.Text = (System.Convert.ToString(MyPortSettingsDialog.cmbPort.SelectedItem) + " ONLINE");
                        //lblOnOff.Location = new Point(729, 580);
                        //panel3.BackColor = Color.Lime;


                        ponto = valorSensor;
                                ponto = ponto / 5;

                                if(ponto < 10) 
                                {
                                    //lblVolts.Location = new Point(84, 30);
                                }        

                                else if (ponto <= 12)
                                {
                                    lblVolts.ForeColor = Color.Yellow;
                                   // lblVolts.Location = new Point(69, 30);
                                 }

                                else if (ponto > 12 && ponto < 15)
                                {
                                    lblVolts.ForeColor = Color.Lime;
                                   // lblVolts.Location = new Point(69, 30);
                                }

                                else if (ponto >= 15)
                                {
                                    lblVolts.ForeColor = Color.Red;
                                   // lblVolts.Location = new Point(69, 30);
                                 }

                                lblVolts.Text = Convert.ToString(ponto + " V");
                                break;


                           
                               


                            case "A":  //leituras TPS
                        timerDados = 0;
                        reconectar = 1;

                        lblOnOff.Text = "ONLINE";
                        //lblOnOff.Location = new Point(729, 580);
                        panel3.BackColor = Color.Lime;

                        timerReconecta.Enabled = false;
                        progressBar1.Visible = false;

                        int tpsReal = (valorSensor * 6)/4;
                                try
                                {

                            //label4.Text = tpsReal.ToString();
                                     if (valorSensor > 100)
                                      {
                                        valorSensor = 100;
                                      }
                                     else if(valorSensor <= 16)
                                     {
                                       valorSensor = 5;
                                     }
                                }
                                catch
                                {


                                    if(valorSensor > 100)
                                    {
                                       valorSensor = 100;
                                    }

                                     else if(valorSensor <= 16)
                                     {
                                       valorSensor = 5;
                                     }


                                }

                                circularTPS.Value = valorSensor;    
                                circularTPS.Text = Convert.ToString(circularTPS.Value + "%");
                                cron = 0;
                                cron1 = 0;
                                rtbMonitor.Enabled = true;

                               

                                //timerReconecta.Enabled = false;
                                label5.Visible = false;
                                label6.Visible = false;
                                timer_cron.Enabled = true;

                                break;

                            case "B": // leituras temp ar
                        timerDados = 0;
                        reconectar = 1;

                        lblOnOff.Text = "ONLINE";
                        //lblOnOff.Location = new Point(729, 580);
                        panel3.BackColor = Color.Lime;

                        timerReconecta.Enabled = false;
                        progressBar1.Visible = false;
                        try
                                {
                            // invert = int.Parse(texto[1].Trim());//trin recorta espaos em branco
                            //invert2 = invert * 2;
                            // invert = (invert - invert2) + 99;
                            valorSensor = (valorSensor - 100) * -1;
                                    lblArTemp.Text = Convert.ToString(valorSensor + "C");
                                }

                                catch
                                {
                                    invert = 0;
                                }
                                cron = 0;
                                timerReconecta.Enabled = false;
                                progressBar1.Visible = false;
                                label5.Visible = false;


                                break;

                            case "C": // leituras MAP
                        timerDados = 0;
                        reconectar = 1;

                        lblOnOff.Text = "ONLINE";
                        //lblOnOff.Location = new Point(729, 580);
                        panel3.BackColor = Color.Lime;

                        timerReconecta.Enabled = false;
                        progressBar1.Visible = false;
                        try
                                {
                                
                                if(valorSensor >= 130)
                                {
                                circularMAP.Value = 130;

                                }
                                  else
                                   {
                                    ponto = valorSensor+2;
                                    circularMAP.Value = (int)ponto;
                                   }
                                    

                               
                                
                                }
                                catch
                                {
                                    circularMAP.Value = 0;
                                }


                                circularMAP.Text = Convert.ToString(circularMAP.Value);

                                cron = 0;
                              
                                    //lblOnOff.Text = (System.Convert.ToString(MyPortSettingsDialog.cmbPort.SelectedItem) + " ONLINE");
                                    //lblOnOff.Location = new Point(729, 580);
                                    //panel3.BackColor = Color.Lime;
                                


                                break;



                            case "D": //Leituras Mapa Injeo BAIXA
                        timerDados = 0;
                        reconectar = 1;

                        lblOnOff.Text =  "ONLINE";
                        //lblOnOff.Location = new Point(729, 580);
                        panel3.BackColor = Color.Lime;

                        timerReconecta.Enabled = false;
                        progressBar1.Visible = false;
                        try
                                    {
                                        mapBaixa.Value = (int)(valorSensor * 1.1);
                                        lblBaixa.Text = Convert.ToString(mapBaixa.Value);
                                    }

                                    catch
                                    {
                                        ponto = 0;

                                    }

                                    
                                    break;

                                case "E": //Leituras Mapa Injeo MEDIA
                        timerDados = 0;
                        reconectar = 1;

                        lblOnOff.Text = "ONLINE";
                        //lblOnOff.Location = new Point(729, 580);
                        panel3.BackColor = Color.Lime;

                        timerReconecta.Enabled = false;
                        progressBar1.Visible = false;
                        try
                                    {
                                      mapMedia.Value = (int)(valorSensor * 1.1);
                                      lblMedia.Text = Convert.ToString(mapMedia.Value);
                                    }

                                    catch
                                    {
                                        ponto = 0;

                                    }

                                    
                                    break;

                                case "F": //Leituras Mapa Injeo ALTA
                        timerDados = 0;
                        reconectar = 1;

                        lblOnOff.Text = "ONLINE";
                        //lblOnOff.Location = new Point(729, 580);
                        panel3.BackColor = Color.Lime;

                        timerReconecta.Enabled = false;
                        progressBar1.Visible = false;
                        try
                                    {
                                     mapAlta.Value = (int)(valorSensor * 1.1);
                                    lblAlta.Text = Convert.ToString(mapAlta.Value);
                                    }

                                    catch
                                    {
                                        ponto = 0;

                                    }    
                                    break;



                       
                }
            }
        }

        private void tmrDecode_Tick(object sender, EventArgs e)
        {
            Decodifica(rtbMonitor.Text);
        }

       

        private void MainForm_Load(object sender, EventArgs e)
        {

        }

        private void btnOpenOrClosePort_Click_1(object sender, EventArgs e)
        {
            if(timer_cron.Enabled == true)
            {   
                rtbMonitor.Enabled = false;
                rtbMonitor.Clear();
                
                timer_cron.Enabled = false;
                timerAtualiza.Enabled = false;
                timerReconecta.Enabled = false;

                panel3.BackColor = Color.Red;
                lblOnOff.Text = "OFFLINE";
               // lblOnOff.Location = new Point(729, 580);

                lblVolts.Text = "0 V";
                lblMotor.Text = "0C";
                lblArTemp.Text = "0C";


                circularTPS.Value = 0;
                circularTPS.Text = "0%";

                circularMAP.Value = 0;
                circularMAP.Text = "0";

                mapBaixa.Value = 100;
                lblBaixa.Text = Convert.ToString(mapBaixa.Value);

                mapAlta.Value = 100;
                lblAlta.Text = Convert.ToString(mapAlta.Value);

                mapMedia.Value = 100;
                lblMedia.Text = Convert.ToString(mapMedia.Value);


            }
            else
            {   
                rtbMonitor.Clear();
                rtbMonitor.Enabled = true;
                timer_cron.Enabled = true;
                timerAtualiza.Enabled = true;
                timerReconecta.Enabled = true;
            }
        }

        private void barraStatus_ItemClicked(object sender, ToolStripItemClickedEventArgs e)
        {

        }

        private void textBox5_TextChanged(object sender, EventArgs e)
        {

        }

        private void label11_Click(object sender, EventArgs e)
        {

        }

        private void panel7_Paint(object sender, PaintEventArgs e)
        {

        }

        private void btnPort_Click_1(object sender, EventArgs e)
        {
            btnOpenOrClosePort.Visible = true;
            btnOpenOrClosePort.Enabled = true;
        }

        private void button1_Click(object sender, EventArgs e)
        {
            timer_cron.Enabled = false;
            timerAtualiza.Enabled = false;
            timerReconecta.Enabled = false;

            panel3.BackColor = Color.Red;
            lblOnOff.Text = "OFFLINE";
            //lblOnOff.Location = new Point(729, 580);

            lblVolts.Text = "0 V";
            lblMotor.Text = "0C";
            lblArTemp.Text = "0C";


            circularTPS.Value = 0;
            circularTPS.Text = "0%";

            circularMAP.Value = 0;
            circularMAP.Text = "0";

            mapBaixa.Value = 100;
            lblBaixa.Text = Convert.ToString(mapBaixa.Value);

            mapAlta.Value = 100;
            lblAlta.Text = Convert.ToString(mapAlta.Value);

            mapMedia.Value = 100;
            lblMedia.Text = Convert.ToString(mapMedia.Value);

            this.Close();

          
        }

        private void timer_fechar_Tick(object sender, EventArgs e)
        {
             //this.Close();
        }

        private void timer_cron_Tick(object sender, EventArgs e)
        {
            timerDados++;
            cron++;

            if (timerDados >= 2)
            {
                reconectar = 0;
            }

            if (cron == 8)
            {
                cron = 0;
               
            }

            if (cron == 2)
            {

                if (reconectar == 0)
                {
                    panel3.BackColor = Color.Red;
                    lblOnOff.Text = "OFFLINE";
                   // lblOnOff.Location = new Point(729, 580);

                    lblVolts.Text = "0 V";
                    lblMotor.Text = "0C";
                    lblArTemp.Text = "0C";


                    circularTPS.Value = 0;
                    circularTPS.Text = "0%";

                    circularMAP.Value = 0;
                    circularMAP.Text = "0";

                }

                else
                {

                    lblOnOff.Text = "ONLINE";
                  //  lblOnOff.Location = new Point(729, 580);
                    panel3.BackColor = Color.Lime;

                    timerReconecta.Enabled = false;
                    progressBar1.Visible = false;
                }
                   
                
                // UserPort1.CloseComPort(UserPort1.SelectedPort);
                //timer_cron.Enabled = false;
               



                if (UserPort1.SelectedPort.IsOpen && reconectar == 0)
                {

                        lblOnOff.Text = "Rastreando";
                      //  lblOnOff.Location = new Point(685, 580);

                        timerReconecta.Enabled = true;
                        UserPort1.CloseComPort(UserPort1.SelectedPort);


                        lblVolts.Text = "0 V";
                        lblMotor.Text = "0C";
                        lblArTemp.Text = "0C";

                       
                        circularTPS.Value = 0;
                        circularTPS.Text = "0";

                        
                        circularMAP.Value = 0;
                        circularMAP.Text = "0";
                    

                }
                else if(reconectar == 1)
                {
                    UserPort1.OpenComPort();
                    lblOnOff.Text = "ONLINE";
                    //lblOnOff.Location = new Point(729, 580);
                    panel3.BackColor = Color.Lime;

                    timerReconecta.Enabled = false;
                    progressBar1.Visible = false;
                }

            }
        }

        private void lbl_VOLT_Click(object sender, EventArgs e)
        {

        }

        private void lbl_tAR_Click(object sender, EventArgs e)
        {

        }

        private void timerReconecta_Tick(object sender, EventArgs e)
        {
            if(cron == 2)
            {
               if(reconectar == 0)
                {
                    label5.Text = "Reconectando";
                    label5.Visible = true;
                    label6.Visible = true;
                    //UserPort1.CloseComPort(UserPort1.SelectedPort);
                    progressBar1.Visible = true;
                }
                else
                {
                    lblOnOff.Text = "ONLINE";
                   // lblOnOff.Location = new Point(729, 580);
                    panel3.BackColor = Color.Lime;
                    progressBar1.Visible = true;

                    timerReconecta.Enabled = false;
                }



            }

            else if(cron == 4)
            {
                //progressBar1.Visible = false;
                //label5.Visible = false;
                //timer_cron.Enabled = true;

                UserPort1.OpenComPort();
                cron1++;
                if(cron1 == 4)
                {

                    if (reconectar == 0)
                    {
                        lblOnOff.Text = ("Tentando novamente!");
                        //lblOnOff.Location = new Point(700, 580);
                    }
                    else
                    {
                        lblOnOff.Text = "ONLINE";
                       // lblOnOff.Location = new Point(729, 580);
                        panel3.BackColor = Color.Lime;
                        timerReconecta.Enabled = false;
                        progressBar1.Visible = false;
                    }


                }

                else if (cron1 == 6)
                {
                    if (reconectar == 0)
                    {
                        lblOnOff.Text = ("Tentando novamente!");
                        //lblOnOff.Location = new Point(700, 580);
                    }
                    else
                    {
                        lblOnOff.Text = "ONLINE";
                       // lblOnOff.Location = new Point(729, 580);
                        panel3.BackColor = Color.Lime;
                        timerReconecta.Enabled = false;
                        progressBar1.Visible = false;
                    }
                    
                }


                else if (cron1>=7)
                {
                    UserPort1.CloseComPort(UserPort1.SelectedPort);
                    timerReconecta.Enabled = false;
                    timer_cron.Enabled = false;
                    cron = 0;
                    cron1 = 0;
                    progressBar1.Visible = false;
                    label5.Visible = false;
                    label6.Visible = false;

                   
                  
                        lblOnOff.Text = "Bluetooth\nno\nencontrado!";
                        //lblOnOff.Location = new Point(640, 580);
                    
                    
                    MessageBox.Show("Nenhum sistema de Injeo encontrado! Por favor, ligue a chave de ignio e tente novamente.", "AVISO", MessageBoxButtons.OK, MessageBoxIcon.Warning);

                }
            }
        }

        private void progressBar1_Click(object sender, EventArgs e)
        {

        }

        private void lblOnOff_Click(object sender, EventArgs e)
        {

        }

       

        private void button1_Click_1(object sender, EventArgs e)
        {

        }

        private void timerAtualiza_Tick(object sender, EventArgs e)
        {

        }

        private void panel1_Paint(object sender, PaintEventArgs e)
        {

        }

        private void circularMAP_MouseHover(object sender, EventArgs e)
        {
            toolTip.ToolTipTitle = "MAP";
            toolTip.SetToolTip(circularMAP, "Leitura da presso atmosfrica\n100 = 1ATM (Presso ao nvel do mar).");
        }

        private void circularTPS_MouseHover(object sender, EventArgs e)
        {
            toolTip.ToolTipTitle = "TPS";
            toolTip.SetToolTip(circularTPS, "Percentual de abertura do acelerador.");
        }

        private void mapBaixa_MouseHover(object sender, EventArgs e)
        {
            toolTip.ToolTipTitle = "Ajuste Baixa";
            toolTip.SetToolTip(mapBaixa, "Ajuste de combustvel entre 0-3000 RPM.");
        }

        private void mapMedia_MouseHover(object sender, EventArgs e)
        {
            toolTip.ToolTipTitle = "Ajuste Mdia";
            toolTip.SetToolTip(mapMedia, "Ajuste de combustvel entre 3000-6000 RPM.");
        }

        private void mapAlta_MouseHover(object sender, EventArgs e)
        {
            toolTip.ToolTipTitle = "Ajuste Alta";
            toolTip.SetToolTip(mapAlta, "Ajuste de combustvel maior que 6000 RPM.");
        }

        private void lblVolts_MouseHover(object sender, EventArgs e)
        {
            toolTip.ToolTipTitle = "Voltagem";
            toolTip.SetToolTip(lblVolts, "Tenso bateria.");
        }

        private void lblMotor_MouseHover(object sender, EventArgs e)
        {
            toolTip.ToolTipTitle = "Motor";
            toolTip.SetToolTip(lblMotor, "Temperatura do motor.");
        }

        private void lblArTemp_MouseHover(object sender, EventArgs e)
        {
            toolTip.ToolTipTitle = "Temp. Ar";
            toolTip.SetToolTip(lblArTemp, "Temperatura do ar.");
        }
    }   
} 
